ObjectArx设置图面视图

void SetView(AcGePoint2d Pt1, AcGePoint2d Pt2, double ex_ratio)
{
	AcGePoint2d CenterPt;
	if ((fabs(Pt1.x - Pt2.x) < 1e-6) || (fabs(Pt1.y - Pt2.y) < 1e-6))
	{
		return;
	}
		
	//确保两个坐标点分别为左上角和右下角
	if (Pt1.x>Pt2.x) 
	{
		double tmp;
		tmp = Pt1.x;
		Pt1.x = Pt2.x;
		Pt2.x = tmp;
	}
	if (Pt2.y>Pt1.y) 
	{
		double tmp;
		tmp = Pt1.y;
		Pt1.y = Pt2.y;
		Pt2.y = tmp;
	}

	//获取当前DwgView的尺寸
	CRect CADrect;
	acedGetAcadDwgView()->GetClientRect(&CADrect);
	double width, height, ratio;
	ratio = (double)(CADrect.right - CADrect.left) / (double)(CADrect.bottom - CADrect.top);
	if (fabs(ratio) < 1e-6)
	{
		return;
	}
	if ((Pt2.x - Pt1.x) / (Pt1.y - Pt2.y) > ratio) 
	{
		width = Pt2.x - Pt1.x;
		height = width / ratio;
	}
	else 
	{
		height = Pt1.y - Pt2.y;
		width = height * ratio;
	}

	//设置当前视图中心点
	CenterPt.x = (Pt1.x + Pt2.x) / 2;
	CenterPt.y = (Pt1.y + Pt2.y) / 2;

	//改变当前视图
	AcDbViewTableRecord pVwRec;
	pVwRec.setCenterPoint(CenterPt);
	pVwRec.setWidth(width * ex_ratio);
	pVwRec.setHeight(height * ex_ratio);
	acedSetCurrentView(&pVwRec, NULL);
}

此函数可进行CAD视图设置操作,功能类似ZOOM中的选择两点进行视区缩放功能。

出入两点坐标,传入缩放半径。

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 1
    评论
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

码农709

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值